 
      PROCEDURE addit (m : INTEGER);
         (* adds the species one by one, recursively *)
         TYPE valarray = ARRAY[1..maxsz] OF REAL;
            placearray = ARRAY[1..maxsz] OF INTEGER;
         VAR i, n : INTEGER;
            valyew : valarray;
            place : placearray;
            oldfrac, oldfdone : REAL;
 
         PROCEDURE addtraverse (a, b, c : pointer);
            (* traverse all places to add b *)
         BEGIN (* addtraverse *)
            IF NOT done
            THEN BEGIN
               IF NOT (noroot AND ((a = root) OR (a = root^.leftdesc)))
               THEN BEGIN
                  add (a, b, c);
                  n := n + 1;
                  evaluate (root, m);
                  examined := examined + 1;
                  IF examined = howoften
                  THEN BEGIN
                     examined := 0;
                     mults := mults + 1;
                     IF mults = howmany
                     THEN done := TRUE;
                     WRITE(OUTPUT, ' ', mults:7);
                     IF bestyet >= 0
                     THEN WRITE(OUTPUT,  bestyet:18:5)
                     ELSE WRITE(OUTPUT, '         -        ');
                     WRITELN(OUTPUT, nextree-1:15, fracdone*100:20:2);
                     END;
                  valyew[n] := like;
                  place[n] := a^.index;
                  remove (b, c);
                  END;
               IF NOT a^.tip
               THEN BEGIN
                  addtraverse (a^.leftdesc, b, c);
                  addtraverse (a^.rtdesc, b, c);
                  END;
               END;
         END; (* addtraverse *)
 
         PROCEDURE shellsort (VAR a : valarray; VAR b : placearray;
                                n : INTEGER);
            (* Shell sort keeping a, b in same order *)
            VAR gap, i, j, itemp : INTEGER;
              rtemp : REAL;
         BEGIN (* shellsort *)
            gap := n DIV 2;
            WHILE (gap > 0) DO BEGIN
               FOR i := gap TO n-1 DO BEGIN
                  j := i - gap + 1;
                  WHILE (j>0) DO BEGIN
                     IF a[j] > a[j+gap]
                     THEN BEGIN
                        rtemp := a[j];
                        a[j] := a[j+gap];
                        a[j+gap] := rtemp;
                        itemp := b[j];
                        b[j] := b[j+gap];
                        b[j+gap] := itemp;
                        END;
                     j := j - gap;
                     END;
                  END;
               gap := gap DIV 2;
               END;
         END; (* shellsort *)
 
      BEGIN (* addit *)
         n := 0;
         addtraverse (root, treenode[m], treenode[spp+m-1]);
         shellsort (valyew, place, n);
         oldfrac := fracinc;
         oldfdone := fracdone;
         IF n > 0 THEN fracinc := fracinc / n;
         FOR i := 1 TO n DO BEGIN
            IF (valyew[i] <= bestyet) OR (bestyet < 0.0)
            THEN BEGIN
               current[m] := place[i];
               add(treenode[place[i]], treenode[m],
                                         treenode[spp+m-1]);
               IF m < spp
               THEN addit (m+1)
               ELSE BEGIN
                  IF (valyew[i] < bestyet) OR (bestyet < 0.0)
                  THEN BEGIN
                     nextree := 1;
                     bestyet := valyew[i];
                     END;
                  IF nextree <= maxtrees
                  THEN BEGIN
                     bestrees[nextree] := current;
                     nextree := nextree + 1;
                     END;
                  END;
               remove (treenode[m], treenode[spp+m-1]);
               END;
            fracdone := fracdone + fracinc;
            END;
         fracinc := oldfrac;
         fracdone := oldfdone;
      END; (* addit *)
 
      PROCEDURE reroot (outgroup : pointer);
         (* reorients tree, putting outgroup in desired position.
            Written by Kent Fiala *)
         VAR vertex, oldvertex, ante, otherbranch : pointer;
            left : BOOLEAN;
      BEGIN (* reroot *)
         IF NOT (outgroup^.ancestor = root)
         THEN BEGIN
            oldvertex := outgroup;
            vertex := outgroup^.ancestor;
            ante := vertex^.ancestor;
            IF vertex^.rtdesc = outgroup
            THEN BEGIN
               vertex^.rtdesc := vertex^.leftdesc;
               vertex^.leftdesc := outgroup;
               END;
            REPEAT
               IF oldvertex = vertex^.leftdesc
               THEN BEGIN
                  vertex^.leftdesc := ante;
                  left := TRUE;
                  END
               ELSE BEGIN
                  vertex^.rtdesc := ante;
                  left := FALSE;
                  END;
               vertex^.ancestor := oldvertex;
               oldvertex := vertex;
               vertex := ante;
               ante := vertex^.ancestor
            UNTIL vertex = root;
            IF root^.leftdesc = oldvertex
            THEN otherbranch := root^.rtdesc
            ELSE otherbranch := root^.leftdesc;
            IF left
            THEN oldvertex^.leftdesc := otherbranch
            ELSE oldvertex^.rtdesc := otherbranch;
            otherbranch^.ancestor := oldvertex;
            root^.rtdesc := outgroup^.ancestor;
            root^.leftdesc := outgroup;
            outgroup^.ancestor^.ancestor := root;
            outgroup^.ancestor := root;
            END;
      END; (* reroot *)
 
      PROCEDURE printree;
         (* prints out diagram of the tree *)
         CONST down = 2;
            over = 3;
         VAR tipx, tipy, i, rover : INTEGER;
 
         PROCEDURE coordinates (p : pointer);
            (* establishes coordinates of nodes *)
         BEGIN (* coordinates *)
            IF p^.tip
            THEN BEGIN
               p^.xcoord := tipx;
               p^.ycoord := tipy;
               tipx := tipx + rover;
               tipy := tipy + down;
               END
            ELSE BEGIN
               coordinates (p^.leftdesc);
               p^.xcoord := p^.leftdesc^.xcoord;
               coordinates (p^.rtdesc);
               p^.ycoord := p^.rtdesc^.ycoord;
               END;
         END; (* coordinates *)
 
         PROCEDURE drawline (i : INTEGER);
            (* draws one row of the tree diagram by moving up tree *)
            VAR p, q : pointer;
               n, j : INTEGER;
         BEGIN (* drawline *)
            p :=root;
            WRITE(OUTPUT, '   ');
            REPEAT
               IF p^.leftdesc^.ycoord >= i
               THEN p := p^.leftdesc
               ELSE BEGIN
                  q := p^.rtdesc;
                  n := q^.xcoord - p^.xcoord;
                  IF p^.ycoord = i
                  THEN BEGIN
                     IF (i = (tipy-down)) AND noroot
                       AND (p^.xcoord = 0)
                     THEN WRITE(OUTPUT, 'L')
                     ELSE WRITE(OUTPUT, '*');
                     FOR j := 1 TO n-1 DO WRITE(OUTPUT, '-');
                     END
                  ELSE BEGIN
                     WRITE(OUTPUT, '!');
                     FOR j := 1 TO n-1 DO WRITE(OUTPUT, ' ');
                     END;
                  p := q;
                  END;
            UNTIL p^.tip;
            IF p^.ycoord = i
            THEN FOR j := 1 TO nmlngth DO
                       WRITE(OUTPUT, name[p^.index, j]);
            WRITELN(OUTPUT);
         END; (* drawline *)
 
      BEGIN (* printree *)
         tipx := 0;
         tipy := 1;
         rover := 100 DIV spp;
         IF rover > over THEN rover := over;
         coordinates (root);
         WRITELN(OUTPUT, ' ');
         FOR i := 1 TO tipy-down DO drawline (i);
         IF noroot
         THEN BEGIN
            WRITELN(OUTPUT);
            WRITE(OUTPUT, '   remember:');
            IF didreroot
            THEN WRITE(OUTPUT, ' (although rooted by outgroup)');
            WRITELN(OUTPUT, ' this is an unrooted tree!');
            END
         ELSE BEGIN
            WRITELN(OUTPUT, '  /');
            WRITELN(OUTPUT, ' /');
            END;
         WRITELN(OUTPUT);
      END; (* printree *)
 
      PROCEDURE describe;
         (* prints number of steps and table of numbers of steps in
            each character *)
         VAR i, j, k : INTEGER;

         PROCEDURE hypstates;
            (* fill in and describe states at interior nodes *)
            VAR i, j, k : INTEGER;
               unknown : BOOLEAN;
               dohyp : bitarray;

            PROCEDURE filltrav (r : pointer);
               (* traverse to fill in interior node states *)
            BEGIN (* filltrav *)
               IF NOT r^.tip
               THEN BEGIN
                  filltrav (r^.leftdesc);
                  filltrav (r^.rtdesc);
                  fillin (r);
                  END;
            END; (* filltrav *)

            PROCEDURE hyptrav (r : pointer);
               (*  compute, print out states at one interior node *)
               VAR i : INTEGER;
                  bottom, maybe, nonzero : BOOLEAN;
                  zerobelow, onebelow : bitarray;

               PROCEDURE hyprint;
                  (* print out states at node *)
                  VAR i, j, k  : INTEGER;
                     l : bitrange;
               BEGIN (* hyprint *)
                  IF bottom
                  THEN BEGIN
                     IF (noroot AND (NOT didreroot))
                     THEN WRITE(OUTPUT, '        ')
                     ELSE WRITE(OUTPUT, ' root   ');
                     END
                  ELSE WRITE(OUTPUT,
                       (r^.ancestor^.index - spp):4, '    ');
                  IF r^.tip
                  THEN FOR i := 1 TO nmlngth DO
                     WRITE(OUTPUT, name[r^.index, i])
                  ELSE WRITE(OUTPUT, (r^.index - spp):4, '      ');
                  IF bottom
                  THEN WRITE(OUTPUT, '          ')
                  ELSE IF nonzero
                     THEN WRITE(OUTPUT, '   yes    ')
                     ELSE If unknown
                        THEN WRITE(OUTPUT, '    ?     ')
                        ELSE IF maybe
                           THEN WRITE(OUTPUT, '  maybe   ')
                           ELSE WRITE(OUTPUT, '   no     ');
                  FOR j := 1 TO chars DO BEGIN
                     newline(j, 40, nmlngth+18);
                     k := (j-1) DIV bits + 1;
                     l := (j-1) MOD bits + 1;
                     IF (NOT (l IN wagner[k])) AND (bestguess[j] = '?')
                     THEN WRITE(OUTPUT, '.')
                     ELSE BEGIN
                        IF l IN r^.statezero[k]
                        THEN WRITE(OUTPUT, '0')
                        ELSE IF l IN r^.stateone[k]
                           THEN WRITE(OUTPUT, '1')
                           ELSE WRITE(OUTPUT, '?');
                        END;
                     IF (j MOD 5) = 0
                     THEN WRITE(OUTPUT, ' ');
                     END;
                  WRITELN(OUTPUT);
               END; (* hyprint *)

            BEGIN (* hyptrav *)
               bottom := (r^.ancestor = NIL);
               maybe := FALSE;
               nonzero := FALSE;
               IF bottom
               THEN BEGIN
                  zerobelow := zeroanc;
                  onebelow := oneanc;
                  END
               ELSE BEGIN
                  zerobelow := r^.ancestor^.statezero;
                  onebelow := r^.ancestor^.stateone;
                  END;
               FOR i := 1 TO words DO BEGIN
                  IF NOT r^.tip
                  THEN BEGIN
                     r^.statezero[i] := wagner[i]
                      * (zerobelow[i] * r^.leftdesc^.statezero[i]
                         + zerobelow[i] * r^.rtdesc^.statezero[i]
                         + r^.leftdesc^.statezero[i]
                          * r^.rtdesc^.statezero[i])
                      + dohyp[i] * (fullset-wagner[i])
                         * r^.statezero[i];
                     r^.stateone[i] := wagner[i]
                      * (onebelow[i] * r^.leftdesc^.stateone[i]
                         + onebelow[i] * r^.rtdesc^.stateone[i]
                         + r^.leftdesc^.stateone[i]
                          * r^.rtdesc^.stateone[i])
                       + dohyp[i] * (fullset-wagner[i])
                          * r^.stateone[i];
                     END;
                  maybe := maybe OR (dohyp[i] *
                          (r^.stateone[i] + r^.statezero[i])
                              <> (zerobelow[i] + onebelow[i]));
                  nonzero := nonzero OR ((r^.stateone[i] * zerobelow[i]
                              + r^.statezero[i] * onebelow[i]) <> []);
                  END;
               IF (NOT bottom) OR (NOT noroot) OR didreroot
               THEN hyprint;
               IF NOT r^.tip
               THEN BEGIN
                  hyptrav (r^.leftdesc);
                  hyptrav (r^.rtdesc);
                  END;
            END; (* hyptrav *)

         BEGIN (* hypstates *)
            FOR i := 1 TO words DO BEGIN
               zeroanc[i] := [];
               oneanc[i] := [];
               END;
            unknown := FALSE;
            FOR i := 1 TO chars DO BEGIN
               j := (i-1) DIV bits + 1;
               k := (i-1) MOD bits + 1;
               IF (bestguess[i] = '0')
               THEN zeroanc[j] := zeroanc[j] + [k];
               IF (bestguess[i] = '1')
               THEN oneanc[j] := oneanc[j] + [k];
               unknown := unknown OR ((NOT (k IN wagner[j]))
                                     AND (bestguess[i] = '?'));
               END;
            FOR i := 1 TO words DO
               dohyp[i] := wagner[i] + zeroanc[i] + oneanc[i];
            filltrav (root);
            WRITELN(OUTPUT);
            WRITE(OUTPUT, ' From    To     Any Steps?    ');
            WRITELN(OUTPUT, 'State at upper node');
            WRITELN(OUTPUT, ' ');
            hyptrav (root);
         END; (* hypstates *)

      BEGIN (* describe *)
         IF weights THEN WRITE(OUTPUT, ' weighted');
         WRITELN(OUTPUT, ' steps in each character:');
         WRITE(OUTPUT, '       ');
         FOR i := 0 TO 9 DO WRITE(OUTPUT, i:4);
         WRITELN(OUTPUT);
         WRITE(OUTPUT, '      *------------------------------------');
         WRITELN(OUTPUT, '-----');
         FOR i := 0 TO (chars DIV 10) DO BEGIN
            WRITE(OUTPUT, 10*i:6);
            WRITE(OUTPUT, '!');
            FOR j := 0 TO 9 DO BEGIN
               k := 10*i + j;
               IF (k = 0) OR (k > chars)
               THEN WRITE(OUTPUT, '    ')
               ELSE WRITE(OUTPUT, numsteps[k]+extras[k]:4);
               END;
            WRITELN(OUTPUT);
            END;
         WRITELN(OUTPUT);
         IF questions AND ((NOT noroot) OR didreroot)
         THEN BEGIN
            WRITELN(OUTPUT, ' best guesses of ancestral states:');
            WRITE(OUTPUT, '       ');
            FOR i := 0 TO 9 DO WRITE(OUTPUT, i:2);
            WRITELN(OUTPUT);
            WRITELN(OUTPUT, '      *--------------------');
            FOR i := 0 TO (chars DIV 10) DO BEGIN
               WRITE(OUTPUT, ' ');
               WRITE(OUTPUT, 10*i:5, '!');
               FOR j := 0 TO 9 DO
                  IF (10*i+j = 0) OR (10*i+j > chars)
                  THEN WRITE(OUTPUT, '  ')
                  ELSE WRITE(OUTPUT, ' ', bestguess[10*i+j]);
               WRITELN(OUTPUT);
               END;
            WRITELN(OUTPUT);
            END;
         hypstates;
         WRITELN(OUTPUT);
      END; (* describe *)
 
   BEGIN (* maketree *)
      fullset := [1..bits];
      WRITELN(OUTPUT, ' How many');
      WRITELN(OUTPUT, ' trees looked                ',
               '                       Approximate');
      WRITELN(OUTPUT, ' at so far      Length of    ',
               '    How many           percentage');
      WRITELN(OUTPUT, ' (multiples     shortest tree',
               '    trees this long    searched');
      WRITELN(OUTPUT, ' of ', howoften:4, '):', '      found so far ',
               '    found so far       so far');
      WRITELN(OUTPUT, ' ----------     ------------ ',
               '    ------------       ------------');
      done := FALSE;
      mults := 0;
      examined := 0;
      nextree := 1;
      k := 3;
      root := treenode[1];
      add (treenode[1], treenode[2], treenode[spp+1]);
      IF noroot
      THEN BEGIN
         add(treenode[spp+1], treenode[3], treenode[spp+2]);
         k := k + 1;
         END;
      fracdone := 0.0;
      fracinc := 1.0;
      addit (k);
      IF done
      THEN BEGIN
         WRITELN(OUTPUT, ' Search broken off!  Not guaranteed to');
         WRITELN(OUTPUT, '  have found the most parsimonious');
         WRITELN(OUTPUT, '  trees, but here is what we found:');
         END;
      WRITELN(OUTPUT);
      WRITELN(OUTPUT, ' requires a total of ',bestyet:18:3);
      WRITELN(OUTPUT);
      IF (nextree = 2)
      THEN WRITELN(OUTPUT, ' One most parsimonious tree found:')
      ELSE WRITELN(OUTPUT, nextree-1:6, ' trees in all found');
      IF nextree > maxtrees + 1
      THEN WRITELN(OUTPUT, ' here are the first', maxtrees:4,
                     ' of them');
      WRITELN(OUTPUT);
      FOR i := 1 TO nextree-1 DO BEGIN
         FOR j := k TO spp DO
            add(treenode[bestrees[i][j]], treenode[j],
                                           treenode[spp+j-1]);
         IF outgropt AND noroot
         THEN BEGIN
            reroot (treenode[outgrno]);
            didreroot := TRUE;
            END;
         evaluate (root, spp);
         IF questions AND ((NOT noroot) OR outgropt)
         THEN bestguess := guess;
         printree;
         describe;
         FOR j := k TO spp DO
            remove (treenode[j], treenode[spp+j-1]);
         END;
   END; (* maketree *)
 
BEGIN (* Penny's branch-and-bound method *)
   (* Reads in the number of species, number of characters,
      options and data.  Then finds all most parsimonious trees *)
   RESET(infile);
   doinput;
   maketree;
  (*  CLOSE(infile);  -- may need this here *)
END. (* Penny's branch-and-bound method *)
