
      PROCEDURE placenodes(p : nodeptr; VAR count : INTEGER);
      BEGIN (* placenodes *)
         IF p^.descendant = NIL
            THEN BEGIN
               p^.left := p;
               p^.right := p;
               count := count+1;
               p^.x := (count-1)/(ntips-1);
               CASE vertical OF
                  top: p^.level := 1.0-p^.fromtop/maxdepth;
                  bottom: p^.level := p^.frombottom/maxdepth;
                  distance: p^.level := 0.0
                  END;
               p^.nodedone := TRUE;
               END
            ELSE BEGIN
               placenodes(p^.descendant, count);
               p^.left := p^.descendant^.left;
               p^.right := p^.lastdesc^.right;
               IF horizontal = furthest
                  THEN p^.x := (p^.left^.x+p^.right^.x)/2.0
                  ELSE p^.x := (p^.descendant^.x+p^.lastdesc^.x)/2.0;
               CASE vertical OF
                  top: p^.level := 1.0-p^.fromtop/maxdepth;
                  bottom: p^.level := p^.frombottom/maxdepth;
                  distance: p^.level := -(p^.right^.x-p^.left^.x)
                  END;
               END;
         IF p^.sibling <> NIL THEN placenodes(p^.sibling, count);
      END; (* placenodes *)

      PROCEDURE addlengths(p : nodeptr);
         VAR currentlevel : REAL;
      BEGIN (* addlengths *)
         IF p <> root THEN p^.level := p^.level + p^.ancestor^.level;
         IF p^.descendant <> NIL THEN addlengths(p^.descendant);
         IF p^.sibling <> NIL THEN addlengths(p^.sibling);
      END; (* addlengths *)

      PROCEDURE lineupnodes(p : nodeptr);

         PROCEDURE singleline(p : nodeptr; side : sidetype;
               pstart, pend : nodeptr);
         BEGIN (* singleline *)
            WHILE p <> NIL DO BEGIN
               p^.x := (p^.y-pstart^.y)*(pend^.x-pstart^.x)/
                                  (pend^.y-pstart^.y)+pstart^.x;
               p^.nodedone := TRUE;
               IF side = leftside
                  THEN p := p^.descendant
                  ELSE p := p^.lastdesc;
               END;
         END; (* singleline *)

      BEGIN (* lineupnodes *)
         IF p <> NIL THEN BEGIN
            IF NOT p^.nodedone THEN BEGIN
               IF ABS(p^.ancestor^.x-p^.right^.x) >=
                       ABS(p^.ancestor^.x-p^.left^.x)
                  THEN singleline(p, rightside, p^.ancestor,
                     p^.right)
                  ELSE singleline(p, leftside, p^.ancestor,
                     p^.left);
               END;
            lineupnodes(p^.descendant);
            lineupnodes(p^.sibling);
            END;
      END; (* lineupnodes *)

      PROCEDURE levellimits(p : nodeptr);
      BEGIN (* levellimits *)
         IF p^.descendant <> NIL THEN levellimits(p^.descendant);
         IF p^.sibling <> NIL THEN levellimits(p^.sibling);
         IF p^.level > maxlevel THEN maxlevel := p^.level;
         IF p^.level < minlevel THEN minlevel := p^.level;
      END; (* levellimits *)

      PROCEDURE scalenodes(p : nodeptr);
      BEGIN (* scalenodes *)
         IF p^.descendant <> NIL
               THEN scalenodes(p^.descendant);
         IF (leveltips = yes) AND (p^.descendant = NIL)
            THEN p^.y := 1.0
            ELSE p^.y := ABS(p^.level-root^.level)/fullscale;
         IF p^.labels<>NIL THEN p^.labels^.ylab := p^.y;
         IF p^.sibling <> NIL THEN scalenodes(p^.sibling);
      END; (* scalenodes *)

      PROCEDURE setstems(p : nodeptr);
         VAR ptr : nodeptr;
      BEGIN (* setstems *)
         IF p^.descendant <> NIL THEN setstems(p^.descendant);
         p^.xstem := p^.x;
         ptr := p^.descendant;
         WHILE ptr <> NIL DO BEGIN
            ptr^.ystem := p^.y;
            ptr := ptr^.sibling;
            END;
         IF p^.sibling <> NIL THEN setstems(p^.sibling);
      END; (* setstems *)

   BEGIN (* calctree *)
      popout(root);
      counttips(root);
      count := 0;
      placenodes(root, count);
      IF vertical = lengths THEN addlengths(root);
      maxlevel := -bignum;
      minlevel := bignum;
      levellimits(root);
      fullscale := maxlevel-minlevel;
      scalenodes(root);
      IF horizontal = straightline THEN BEGIN
         root^.x := 0.5;
         root^.nodedone := TRUE;
         lineupnodes(root);
         END;
      IF drawing = rectangle THEN setstems(root);
   END; (* calctree *)

   PROCEDURE hardwarecoordinates;
      VAR i : INTEGER;
         factor, xmax, xmin, ymax, ymin, thislength,
            dsin, dcos, lsin, lcos, xtrans, ytrans,
            xcorrect, ycorrect, dummy : REAL;
         lp : labelptr;
         p : nodeptr;

      FUNCTION lengthtext(pstring : plotstring; nchars : INTEGER;
         height, compress : REAL; VAR font : fonttype) : REAL;
         VAR i, j, code, coord : INTEGER;
            sumlength, heightfont, widthfont, yfactor : REAL;
      BEGIN (* lengthext *)
         sumlength := 0.0;
         FOR i := 1 TO nchars DO BEGIN
            code := ORD(pstring[i]);
            j := 1;
            WHILE (font[j+1] <> code) AND (font[j] <> 0) DO
               j := font[j];
            IF font[j+1] = code THEN BEGIN
               heightfont := font[j+2];
               widthfont := font[j+3];
               sumlength := sumlength + (height/heightfont)
                     *widthfont;
               END;
            END;
            lengthtext := sumlength*compress;
      END; (* lengthtext *)

      PROCEDURE rotate(VAR x, y : REAL; xdisp, ydisp, xcenter, ycenter,
             sinrot, cosrot : REAL);
      BEGIN (* rotate *)
         x := xcenter+xdisp*cosrot+ydisp*sinrot;
         IF xmin>x THEN xmin := x;
         IF xmax<x THEN xmax := x;
         y := ycenter-xdisp*sinrot+ydisp*cosrot;
         IF ymin>y THEN ymin := y;
         IF ymax<y THEN ymax := y;
      END; (* rotate *)

   BEGIN (* hardwarecoordinates *)
      xmin := bignum;
      xmax := -bignum;
      ymin := bignum;
      ymax := -bignum;
      dsin := SIN(rotation);
      dcos := COS(rotation);
      lsin := SIN(labelrotation);
      lcos := COS(labelrotation);
      IF widthmode = yes
         THEN BEGIN
            factor := treewidth / ((ntips-1)*(labelheight+spacing));
            IF factor < 1.0
               THEN BEGIN
                  labelheight := labelheight*factor;
                  spacing := spacing*factor;
                  END
               ELSE spacing := (treewidth/(ntips-1)) - labelheight;
            END
         ELSE treewidth := (ntips-1)*(labelheight+spacing);
      xcorrect := -labelheight*(1+SIN(labelrotation-rotation)/2.0);
      ycorrect := -labelheight*COS(labelrotation-rotation)/2.0;
      FOR i := 1 TO nlabels DO BEGIN
         lp := labellist[i];
         lp^.xlab := lp^.tipnum*labelheight +
                           (lp^.tipnum-1)*spacing + xcorrect;
         lp^.ylab := lp^.ylab*treeheight + gap + ycorrect;
         thislength := lengthtext(lp^.lab, lp^.nch, labelheight,
               1.0, font);
         rotate(lp^.xlab,lp^.ylab,lp^.xlab,lp^.ylab,0.0,0.0,dsin,dcos);
         rotate(dummy,dummy,0.0,labelheight,lp^.xlab,lp^.ylab,
               lsin,lcos);
         rotate(dummy,dummy,thislength,labelheight,lp^.xlab,lp^.ylab,
               lsin,lcos);
         rotate(dummy,dummy,thislength,0.0,lp^.xlab,lp^.ylab,lsin,lcos);
         END;
      FOR i := 1 TO nnodes DO BEGIN
         p := nodelist[i];
         p^.x := p^.x * treewidth;
         p^.y := p^.y * treeheight;
         rotate(p^.x,p^.y,p^.x,p^.y,0.0,0.0,dsin,dcos);
         IF drawing = rectangle THEN BEGIN
            p^.xstem := p^.xstem * treewidth;
            p^.ystem := p^.ystem * treeheight;
            rotate(p^.xstem,p^.ystem,p^.xstem,p^.ystem,0.0,0.0,
                  dsin,dcos);
            END;
         END;
      xrange := xmax - xmin;
      yrange := ymax - ymin;
      IF sizemode = yes
         THEN BEGIN
            IF ysize/xsize > yrange/xrange
               THEN factor := xsize/xrange
               ELSE factor := ysize/yrange;
            END
         ELSE factor := 1.0;
      CASE xoption OF
         atroot: BEGIN END;
         right: xtrans := xposition - xmin*factor;
         left: xtrans := xposition - xmax*factor;
         center: xtrans := xposition + (xrange/2.0 - xmax)*factor
         END;
      CASE yoption OF
         atroot: BEGIN END;
         above: ytrans := yposition - ymin*factor;
         below: ytrans := yposition - ymax*factor;
         center: ytrans := yposition + (yrange/2.0 - ymax)*factor
         END;
      FOR i := 1 TO nlabels DO BEGIN
         lp := labellist[i];
         lp^.xlab := (lp^.xlab*factor+xtrans)*xunitspercm;
         lp^.ylab := (lp^.ylab*factor+ytrans)*xunitspercm;
         END;
      FOR i := 1 TO nnodes DO BEGIN
         p := nodelist[i];
         p^.x := (p^.x*factor+xtrans)*xunitspercm;
         p^.y := (p^.y*factor+ytrans)*xunitspercm;
         IF (drawing = rectangle) AND (i <> 1) THEN BEGIN
            p^.xstem := (p^.xstem*factor+xtrans)*xunitspercm;
            p^.ystem := (p^.ystem*factor+ytrans)*xunitspercm;
            END;
         END;
      labelheight := labelheight * factor * xunitspercm;
      xrange := xrange * factor * xunitspercm;
      yrange := yrange * factor * xunitspercm;
   END; (* hardwarecoordinates *)

   PROCEDURE loadfont(VAR font : fonttype);
      VAR i, charstart, hersheynum : INTEGER;
         ch : CHAR;
   BEGIN (* loadfont *)
      ch := 'A';
      i := 0;
      WHILE NOT(EOF(fontfile) OR (ch = ' ')) DO BEGIN
         charstart := i+1;
         READ(fontfile, ch, ch, hersheynum,
            font[charstart+2], font[charstart+3]);
         font[charstart+1] := ORD(ch);
         i := charstart+3;
         REPEAT
            IF (i-(charstart+3)) MOD 10=0 THEN READLN(fontfile);
            i := i+1;
            READ(fontfile,font[i]);
            UNTIL ABS(font[i]) >= 10000;
         READLN(fontfile);
         font[charstart] := i+1;
         END;
      font[charstart] := 0;
      WRITELN(OUTPUT, '  FONT REQUIRES', i:5, ' INTEGERS OUT OF',
         fontsize:5, ' AVAILABLE');
   END; (* loadfont *)

   PROCEDURE plot(penstatus : penstatustype; xabs, yabs : REAL);
      VAR i, n, xrel, yrel, xinc, yinc, xhigh, yhigh,
            xlow, ylow, xlast, ylast : INTEGER;
         quadrant : CHAR;

      PROCEDURE pout(n : INTEGER);
      BEGIN (* pout *)
         IF n >= 1000
            THEN WRITE(plotfile, n:4)
            ELSE IF n >= 100
               THEN WRITE(plotfile, n:3)
               ELSE IF n >= 10
                  THEN WRITE(plotfile, n:2)
                  ELSE IF n >= 0
                     THEN WRITE(plotfile, n:1)
                     ELSE IF n >= -9
                        THEN WRITE(plotfile, n:2)
                        ELSE IF n >= -99
                           THEN WRITE(plotfile, n:3)
                           ELSE IF n >= -999
                              THEN WRITE(plotfile, n:4)
                              ELSE WRITE(plotfile, n:5);
      END; (* pout *)

      BEGIN (* plot *)
         yabs := yabs * aspectratio;
         CASE plotter OF
            calcomp: BEGIN
               IF penstatus = pendown
                  THEN WRITE(plotfile,'H')
                  ELSE WRITE(plotfile,'D');
               xrel := ROUND(xabs) - xnow;
               yrel := ROUND(yabs) - ynow;
               xnow := ROUND(xabs);
               ynow := ROUND(yabs);
               IF xrel > 0
                  THEN IF yrel > 0
                     THEN quadrant := 'P'
                     ELSE quadrant := 'T'
                  ELSE IF yrel > 0
                     THEN quadrant := 'X'
                     ELSE quadrant := '1';
               xrel := ABS(xrel);
               yrel := ABS(yrel);
               IF xrel > yrel
                  THEN n := (xrel DIV 255) + 1
                  ELSE n := (yrel DIV 255) + 1;
               xinc := xrel DIV n;
               yinc := yrel DIV n;
               xlast := xrel MOD n;
               ylast := yrel MOD n;
               xhigh := xinc DIV 16;
               yhigh := yinc DIV 16;
               xlow := xinc MOD 16;
               ylow := yinc MOD 16;
               FOR i := 1 TO n DO
                  WRITE(plotfile, quadrant, cchex[xhigh], cchex[xlow],
                     cchex[yhigh], cchex[ylow]);
               IF (xlast <> 0) OR (ylast <> 0)
                  THEN WRITE(plotfile, quadrant, cchex[0], cchex[xlast],
                     cchex[0], cchex[ylast]);
               END;
            tektronix: BEGIN
               IF penstatus = penup
                  THEN WRITE(plotfile, CHR(29));
               xnow := ROUND(xabs);
               ynow := ROUND(yabs);
               xhigh := xnow DIV 32;
               yhigh := ynow DIV 32;
               xlow := xnow MOD 32;
               ylow := ynow MOD 32;
               IF yhigh <> oldyhigh THEN WRITE(plotfile,
                                                 CHR(yhigh+32));
               IF (ylow <> oldylow) OR (xhigh <> oldxhigh)
                  THEN WRITE(plotfile, CHR(ylow+96));
               IF xhigh <> oldxhigh THEN WRITE(plotfile,
                                                 CHR(xhigh+32));
               WRITE(plotfile, CHR(xlow+64));
               oldxhigh := xhigh;
               oldxlow := xlow;
               oldyhigh := yhigh;
               oldylow := ylow;
               END;
            hp7470: BEGIN
               IF penstatus=pendown
                  THEN WRITE(plotfile, 'PD')
                  ELSE WRITE(plotfile, 'PU');
               pout(ROUND(xabs));
               WRITE(plotfile, ',');
               pout(ROUND(yabs));
               WRITELN(plotfile, ';');
               END;
            bauschlomb: BEGIN
               IF penstatus = pendown
                  THEN WRITE(plotfile, 'D ')
                  ELSE WRITE(plotfile, 'U ');
               pout(ROUND(xabs));
               WRITE(plotfile, ',');
               pout(ROUND(yabs));
               WRITELN(plotfile);
               END;
            other : BEGIN
               (* code for a pen move on a new plotter
                  goes here *)
               END
            END;
      END; (* plot *)

      PROCEDURE plotlabels;
         TYPE pentype = (treepen, labelpen);
         VAR i : INTEGER;
            xlab, ylab, x, y : REAL;
            lp : labelptr;

         PROCEDURE changepen(pen : pentype);
         BEGIN (* changepen *)
            CASE pen OF
               treepen: CASE plotter OF
                  hp7470: WRITELN(plotfile, 'SP1;');
                  bauschlomb: WRITELN(plotfile, 'P1');
                  other : BEGIN
                     (* code for a new plotter goes here *)
                     END
                  END;
               labelpen: CASE plotter OF
                  hp7470: WRITELN(plotfile, 'SP2;');
                  bauschlomb: WRITELN(plotfile, 'P2');
                  other : BEGIN
                     (* code for a new plotter goes here *)
                     END
                  END;
               END;
         END; (* changepen *)

         PROCEDURE plottext(pstring : plotstring; nchars : INTEGER;
            height, compress : REAL; VAR x, y : REAL;
            slope : REAL; VAR font : fonttype);
            CONST xstart = 10;
               ystart = 35;
            VAR i, j, code, coord : INTEGER;
               heightfont, widthfont, xfactor, yfactor, xfont, yfont,
               xplot, yplot, sinslope, cosslope : REAL;
               penstatus : penstatustype;

            PROCEDURE plotchar(VAR place : INTEGER);
            BEGIN (* plotchar *)
               heightfont := font[place+2];
               widthfont := font[place+3];
               yfactor := height/heightfont;
               xfactor := yfactor*compress;
               place := place+3;
               REPEAT
                  place := place+1;
                  coord := font[place];
                  IF coord > 0
                     THEN penstatus := pendown
                     ELSE penstatus := penup;
                  coord := ABS(coord);
                  coord := coord MOD 10000;
                  xfont := ((coord DIV 100) - xstart)*xfactor;
                  yfont := ((coord MOD 100) - ystart)*yfactor;
                  IF slope = 0.0
                     THEN BEGIN
                        xplot := x + xfont;
                        yplot := y + yfont;
                        END
                     ELSE BEGIN
                        xplot := x + xfont*cosslope
                                    + yfont*sinslope;
                        yplot := y - xfont*sinslope
                                    + yfont*cosslope;
                        END;
                  plot(penstatus, xplot, yplot);
                  UNTIL ABS(font[place]) >= 10000;
               x := xplot;
               y := yplot;
            END; (* plotchar *)

         BEGIN (* plottext *)
            IF slope <> 0.0 THEN BEGIN
               sinslope := SIN(slope);
               cosslope := COS(slope);
               END;
            FOR i := 1 TO nchars DO BEGIN
               code := ORD(pstring[i]);
               j := 1;
               WHILE (font[j+1] <> code) AND (font[j] <> 0) DO
                  j := font[j];
               IF font[j+1] = code THEN plotchar(j);
               END;
         END; (* plottext *)

      BEGIN (* plotlabels *)
         IF penchange = yes THEN changepen(labelpen);
         FOR i := 1 TO nlabels DO BEGIN
            lp := labellist[i];
            plottext(lp^.lab,lp^.nch,labelheight,
               1.0,lp^.xlab,lp^.ylab,labelrotation,font);
            END;
         IF penchange = yes THEN changepen(treepen);
      END; (* plotlabels *)

   PROCEDURE slantdrawing(p : nodeptr);
   BEGIN (* slantdrawing *)
      IF p <> NIL THEN BEGIN
         IF p <> root THEN BEGIN
            plot(penup, p^.ancestor^.x, p^.ancestor^.y);
            plot(pendown, p^.x, p^.y);
            END;
         slantdrawing(p^.descendant);
         slantdrawing(p^.sibling);
         END;
   END; (* slantdrawing *)

   PROCEDURE rectdrawing(p : nodeptr);
   BEGIN (* rectdrawing *)
      IF p <> NIL THEN BEGIN
         IF p <> root THEN BEGIN
            IF p = p^.ancestor^.descendant
               THEN BEGIN
                  plot(penup, p^.ancestor^.lastdesc^.xstem,
                         p^.ancestor^.lastdesc^.ystem);
                  plot(pendown, p^.xstem, p^.ystem);
                  plot(pendown, p^.x, p^.y);
                  END
               ELSE BEGIN
                  plot(penup, p^.xstem, p^.ystem);
                  plot(pendown, p^.x, p^.y);
                  END;
            END;
         rectdrawing(p^.descendant);
         rectdrawing(p^.sibling);
         END;
   END; (* rectdrawing *)

   PROCEDURE initplotter;
   BEGIN (* initplotter *)
      CASE plotter OF
         calcomp: BEGIN
            cchex[0] := 'C'; cchex[1] := 'D'; cchex[2] := 'H';
            cchex[3] := 'L'; cchex[4] := 'P'; cchex[5] := 'T';
            cchex[6] := 'X'; cchex[7] := '1'; cchex[8] := '5';
            cchex[9] := '9'; cchex[10] := '/'; cchex[11] := '=';
            cchex[12] := '#'; cchex[13] := '"'; cchex[14] := '''';
            cchex[15] := '@';
            xnow := 0;
            ynow := 0;
            WRITE(plotfile, 'CCCCCCCCCC');
            END;
         tektronix: BEGIN
            oldxhigh := -1;
            oldxlow := -1;
            oldyhigh := -1;
            oldylow := -1;
            WRITE(plotfile, CHR(27), CHR(12));
            END;
         hp7470: WRITELN(plotfile, 'IN;SP1;VS10.0;');
         other : BEGIN
            (* initialization code for a new plotter goes here *)
            END
         END;
      END; (* initplotter *)

      PROCEDURE finishplotter;
      BEGIN (* finishplotter *)
         CASE plotter OF
            calcomp: plot(penup, 0.0, yrange+50.0);
            hp7470: BEGIN
               plot(penup,0.0,0.0);
               WRITELN(plotfile,'SP;');
               END;
            tektronix: WRITELN(plotfile);
            other : BEGIN
               (* termination code for a new plotter goes here *)
               END
            END;
      END; (* finishplotter *)

   PROCEDURE garbagestack;
      VAR i : INTEGER;
   BEGIN (* garbagestack *)
      FOR i := 1 TO nnodes DO BEGIN
         nodelist[i]^.descendant := garbnode;
         garbnode := nodelist[i];
         END;
      FOR i := 1 TO nlabels DO BEGIN
         labellist[i]^.nextlab := garblabel;
         garblabel := labellist[i];
         END;
   END; (* garbagestack *)

BEGIN (* plotgram *)
   WRITELN(OUTPUT, ' PLOTGRAM VERSION 1.1');
   WRITELN(OUTPUT, ' DISTRIBUTED WITH PHYLIP 2.7');
   WRITELN(OUTPUT, ' WRITTEN BY C. MEACHAM, BOTANY DEPT. ',
                               'UNIV. GEORGIA, ATHENS, GA 30602');
   WRITELN(OUTPUT, ' READING OF PARAMETERS BEGINS');
   RESET(parmfile);
   initparms;
   (*  CLOSE(parmfile);   may need this here *)
   WRITELN(OUTPUT, ' READING OF PARAMETERS COMPLETED');
   IF parmsok THEN BEGIN
      RESET(treefile);
      WHILE NOT EOF(treefile) DO BEGIN
         WRITELN(OUTPUT, ' READING OF DIAGRAM BEGINS');
         readtree;
         WRITELN(OUTPUT, ' READING OF DIAGRAM COMPLETED');
         WRITELN(OUTPUT, ' CALCULATION OF DIAGRAM BEGINS');
         calctree(root);
         WRITELN(OUTPUT, ' CALCULATION OF DIAGRAM COMPLETED');
         IF NOT(fontloaded) AND labelspresent THEN BEGIN
            WRITELN(OUTPUT, ' LOADING OF FONT BEGINS');
            RESET(fontfile);
            loadfont(font);
            (* CLOSE(fontfile);   may need this here *)
            WRITELN(OUTPUT, ' LOADING OF FONT COMPLETED');
            fontloaded := TRUE;
            END;
         hardwarecoordinates;
         WRITELN(OUTPUT, ' DRAWING OF DIAGRAM BEGINS');
         REWRITE(plotfile);
         initplotter;
         IF drawing = slant
            THEN slantdrawing(root)
            ELSE rectdrawing(root);
         plotlabels;
         finishplotter;
         WRITELN(OUTPUT, ' DRAWING OF DIAGRAM COMPLETED');
         garbagestack;
         END;
      END;
   (* CLOSE(treefile);   may need this here *)
   (* CLOSE(plotfile);   may need this here *)
   WRITELN(OUTPUT, ' EXECUTION TERMINATED');
END. (* plotgram *)
       WRITELN(OUTPUT, ' CALCULATION OF DIAGRAM COMPLETED');
         IF NOT(fontloaded) AND labelspresent THEN BEGIN
        