PROGRAM Shuffle (infile, outfile, OUTPUT);
   (* version 2.7 *)

CONST maxsp = 30;   (* maximum number of species *)
   namelength = 10; (* number of characters max. in species name *)

TYPE vector = ARRAY [1..maxsp] OF REAL;
   naym = ARRAY[1..namelength] OF CHAR;

VAR infile, outfile : TEXT;
   numsp, power, outgrno, outgrnew : INTEGER;
   x : ARRAY[1..maxsp] OF vector;
   names : ARRAY[1..maxsp] OF naym;
   order : ARRAY[1..maxsp] OF INTEGER;
   lower, upper, outgropt : BOOLEAN;

   FUNCTION letter (ch : CHAR) : BOOLEAN;
   BEGIN (* letter -- works for both ASCII and EBCDIC codes *)
      letter := ((ch >= 'A') AND (ch <= 'I'))
                OR ((ch >= 'J') AND (ch <= 'R'))
                OR ((ch >= 'S') AND (ch <= 'Z'))
                OR ((ch >= 'a') AND (ch <= 'i'))
                OR ((ch >= 'j') AND (ch <= 'r'))
                OR ((ch >= 's') AND (ch <= 'z'));
   END; (* letter *)

   PROCEDURE uppercase (VAR ch : CHAR);
   BEGIN (* uppercase *)
      IF letter(ch) AND (('a' > 'A') AND (ch >= 'a')
                     OR  ('a' < 'A') AND (ch < 'A'))
      THEN ch := CHR(ORD(ch) + ORD('A') - ORD('a'));
   END; (* uppercase *)

   PROCEDURE getnums;
   BEGIN (* getnums *)
      READ(infile, numsp);
      WRITE(outfile, numsp:5);
   END; (* getnums *)

   PROCEDURE getoptions;
      VAR ch : CHAR;
         i, extranum : INTEGER;
   BEGIN (* getoptions *)
      lower := FALSE;
      upper := FALSE;
      outgropt := FALSE;
      power := 2;
      extranum := 0;
      WHILE NOT EOLN(infile) DO BEGIN
         READ(infile, ch);
         uppercase (ch);
         WRITE(outfile, ch);
         IF (ch = 'B') OR (ch = 'L') OR (ch = 'N')
            OR (ch = 'P') OR (ch = 'R') OR (ch = 'O')
         THEN CASE ch OF
               'B' : BEGIN END;
               'L' : lower := TRUE;
               'N' : BEGIN END;
               'O' : BEGIN
                     outgropt := TRUE;
                     extranum := extranum + 1;
                     END;
               'P' : extranum := extranum + 1;
               'R' : upper := TRUE
               END
         ELSE IF ch <> ' '
            THEN WRITELN(OUTPUT, ' Bad Option Character: ', ch);
         END;
      FOR i := 1 TO extranum DO BEGIN
         READLN(infile);
         READ(infile, ch);
         uppercase (ch);
         IF (ch <> 'O')
         THEN BEGIN
            WRITELN(outfile);
            WRITE(outfile, ch);
            END;
         IF (ch = 'O') OR (ch = 'P')
         THEN CASE ch OF
            'O' : READ(infile, outgrno);
            'P' : BEGIN
                  READ(infile, power);
                  WRITE(outfile, power:4);
                  END
            END;
         END;
   END; (* getoptions *)

   PROCEDURE getdata;
      VAR i, j : INTEGER;
         skipit, skipother : BOOLEAN;
   BEGIN (* getdata *)
      FOR i := 1 TO numsp DO BEGIN
         x[i][i] := 0.0;
         READLN(infile);
         FOR j := 1 TO namelength DO READ(infile, names[i][j]);
         FOR j := 1 TO numsp DO BEGIN
            skipit := (lower AND (j >= i)) OR (upper AND (j <= i));
            skipother := (lower AND (i >= j)) OR
                           (upper AND (i <= j));
            IF NOT skipit
            THEN BEGIN
               IF EOLN(infile)
               THEN READLN(infile);
               READ(infile, x[i][j]);
               END;
            IF (NOT skipit) AND skipother THEN x[j][i] := x[i][j];
            END;
         END;
   END; (* getdata *)

   PROCEDURE getorder;
      VAR i : INTEGER;
   BEGIN (* getorder *)
      FOR i := 1 TO numsp DO BEGIN
         IF EOLN(infile) THEN READLN(infile);
         READ(infile, order[i]);
         IF order[i] = outgrno
         THEN outgrnew := i;
         END;
      outgrno := outgrnew; 
   END; (* getorder *)

   PROCEDURE printdata;
      VAR i, j : INTEGER;
   BEGIN (* printdata *)
      WRITELN(outfile);
      IF outgropt
      THEN WRITELN(outfile, 'O ', outgrno:3);
      FOR i := 1 TO numsp DO BEGIN
         FOR j := 1 TO namelength DO 
            WRITE(outfile, names[order[i]][j]);
         WRITE(outfile, ' ');
         FOR j := 1 TO numsp DO BEGIN
            IF upper AND (j <= i) 
            THEN WRITE(outfile, ' ')
            ELSE IF NOT (lower AND (j >= i))
               THEN WRITE(outfile, x[order[i]][order[j]]:10:5);
            IF ((j MOD 7) = 0) AND (j < numsp)
            THEN WRITELN(outfile);
            END;
         WRITELN(outfile);
         END;
   END; (* printdata *)

BEGIN (* shuffle *)
   RESET(infile);
   REWRITE(outfile);
   getnums;
   getoptions;
   getdata;
   getorder;
   printdata;
   (*  close(outfile)  --- may need this here *)
END.

    END;
      outgrno := outgrnew; 
   END; (* getorder *)

   PROCEDURE printdata;
      VAR i, j : INTEGER;
   BEGIN (* printdata *)
      WRITELN(outfile);
      IF outgropt
      THEN WRITELN(outfile, 'O ', outgrno:3);
      FOR i := 1 TO nu